/* groovylint-disable CompileStatic, DuplicateStringLiteral, NestedBlockDepth */
pipeline {
    agent any
    environment {
        REGISTRY_HOST = 'registry.gitlab.com'
        REGISTRY_PROJEC = '/panupong.rongo.shippop/'
        IMAGE_NAME = 'simple-ci-cd-jenkins'
        REGISTRY_USERNAME = credentials('simple-ci-cd-jenkins_deploy-token-username')
        REGISTRY_PASSOWORD = credentials('simple-ci-cd-jenkins_deploy-token-password')
        // GIT_LAB_TAG = 'refs/tags/v.0.0.1'
        GIT_LAB_TAG_HEADER = 'refs/tags/'
    }
    stages {
        stage('echo env') {
            environment {
                GIT_LAB_TAG = 'refs/tags/v.0.0.1'
                VERSION = GIT_LAB_TAG.replaceAll(GIT_LAB_TAG_HEADER, '')
            }
            steps {
                sh 'printenv'
            }
        }

        stage('unit test before merge code to develope branch') {
            when {
                allOf {
                    expression {
                        gitlabActionType == 'MERGE'
                    }
                    expression {
                        gitlabTargetBranch == 'main'
                    }
                    expression {
                        gitlabSourceBranch == 'develop'
                    }
                }
            }
            steps {
                sh 'echo test build before merge code'

                updateGitlabCommitStatus name: 'build', state: 'pending'

                sh 'echo test build project ก่อน merge'

                updateGitlabCommitStatus name: 'build', state: 'success'
            }
        }
        stage('after merge feature to develop') {
            when {
                allOf {
                    expression {
                        gitlabActionType == 'PUSH'
                    }
                    expression {
                        gitlabTargetBranch == 'develop'
                    }
                    expression {
                        gitlabSourceBranch == 'develop'
                    }
                }
            }
            stages {
                stage('push develop image') {
                        environment {
                            DEV_IMAGE = "$REGISTRY_HOST$REGISTRY_PROJEC$IMAGE_NAME:dev"
                        }
                        steps {
                            sh 'echo test_build_dev_image'
                            sh 'docker --version'

                            sh 'docker login -u "$REGISTRY_USERNAME" -p "$REGISTRY_PASSOWORD" "$REGISTRY_HOST"'
                            sh 'echo "$DEV_IMAGE"'
                            sh 'docker build --rm -t "$DEV_IMAGE" .'
                            sh 'docker push "$DEV_IMAGE"'
                            sh 'echo  push to repository success image success'
                            sh 'docker logout "$REGISTRY_HOST"'

                            sh 'echo clear images in jenkins server'
                            sh 'docker images -a'
                            sh 'docker rmi $(docker images --filter "dangling=true" -q --no-trunc)'
                            sh 'docker rmi "$DEV_IMAGE"'
                            sh 'docker images -a'
                            sh 'echo clear images in jenkins server'
                        }
                }
                stage('deploy dev to staging') {
                    steps {
                        echo 'Deploy to statinging server'
                    }
                }
            }
        }
        stage('unit test before merge code to main branch') {
            when {
                allOf {
                    expression {
                        gitlabActionType == 'MERGE'
                    }
                    expression {
                        gitlabTargetBranch == 'develop'
                    }
                    expression {
                        gitlabSourceBranch ==~ /^feature\/.+/
                    }
                }
            }
            steps {
                sh 'echo test build before merge code'

                updateGitlabCommitStatus name: 'build', state: 'pending'

                sh 'echo test build project ก่อน merge'

                updateGitlabCommitStatus name: 'build', state: 'success'
            }
        }
        stage('deploy realase code') {
            environment {
                GIT_LAB_TAG = "$gitlabBranch"
                VERSION = GIT_LAB_TAG.replaceAll(GIT_LAB_TAG_HEADER, '')
                RELEASE_IMAGE = "$REGISTRY_HOST$REGISTRY_PROJEC$IMAGE_NAME:$VERSION"
            }
            when {
                allOf {
                    expression {
                        gitlabActionType == 'TAG_PUSH'
                    }
                    expression {
                        GIT_BRANCH == 'origin/main'
                    }
                }
            }
            stages {
                stage('push relase image') {
                    steps {
                        sh 'echo test_build_dev_image'
                        sh 'docker --version'

                        sh 'docker login -u "$REGISTRY_USERNAME" -p "$REGISTRY_PASSOWORD" "$REGISTRY_HOST"'
                        sh 'echo "$RELEASE_IMAGE"'
                        sh 'docker build --rm -t "$RELEASE_IMAGE" .'
                        sh 'docker push "$RELEASE_IMAGE"'
                        sh 'echo  push to repository success image success'
                        sh 'docker logout "$REGISTRY_HOST"'

                        sh 'echo clear images in jenkins server'
                        sh 'docker images -a'
                        sh 'docker rmi $(docker images --filter "dangling=true" -q --no-trunc)'
                        sh 'docker rmi "$RELEASE_IMAGE"'
                        sh 'docker images -a'
                        sh 'echo clear images in jenkins server'
                    }
                }
                stage('deploy to k8s')  {
                    steps {
                        sh 'echo do some thing to deploy to k8s'
                    }
                }
            }
        }
    }
}
